// This file is generated by kconfig_compiler from knights.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:
    class EnumAnimationSpeed
    {
      public:
      enum type { Instant, Fast, Normal, Slow, COUNT };
    };
    class EnumBorderDisplayType
    {
      public:
      enum type { None, Border, Notation, COUNT };
    };
    class EnumProtocol
    {
      public:
      enum type { XBoard, FICS, None, COUNT };
    };
    class EnumColor
    {
      public:
      enum type { NoColor, White, Black, COUNT };
    };

    static Settings *self();
    ~Settings();

    /**
      Set Theme file for the board
    */
    static
    void setTheme( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Theme" ) ))
        self()->mTheme = v;
    }

    /**
      Get Theme file for the board
    */
    static
    QString theme()
    {
      return self()->mTheme;
    }

    /**
      Set Moves animation speed
    */
    static
    void setAnimationSpeed( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "animationSpeed" ) ))
        self()->mAnimationSpeed = v;
    }

    /**
      Get Moves animation speed
    */
    static
    int animationSpeed()
    {
      return self()->mAnimationSpeed;
    }

    /**
      Set whether the Board is animated during rotating and resizing
    */
    static
    void setAnimateBoard( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "animateBoard" ) ))
        self()->mAnimateBoard = v;
    }

    /**
      Get whether the Board is animated during rotating and resizing
    */
    static
    bool animateBoard()
    {
      return self()->mAnimateBoard;
    }

    /**
      Set chessboard border type
    */
    static
    void setBorderDisplayType( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "borderDisplayType" ) ))
        self()->mBorderDisplayType = v;
    }

    /**
      Get chessboard border type
    */
    static
    int borderDisplayType()
    {
      return self()->mBorderDisplayType;
    }

    /**
      Set show check marker
    */
    static
    void setShowDanger( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "showDanger" ) ))
        self()->mShowDanger = v;
    }

    /**
      Get show check marker
    */
    static
    bool showDanger()
    {
      return self()->mShowDanger;
    }

    /**
      Set show legal moves marker
    */
    static
    void setShowMarker( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "showMarker" ) ))
        self()->mShowMarker = v;
    }

    /**
      Get show legal moves marker
    */
    static
    bool showMarker()
    {
      return self()->mShowMarker;
    }

    /**
      Set show opponents move marker
    */
    static
    void setShowMotion( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "showMotion" ) ))
        self()->mShowMotion = v;
    }

    /**
      Get show opponents move marker
    */
    static
    bool showMotion()
    {
      return self()->mShowMotion;
    }

    /**
      Set time limit for the local player
    */
    static
    void setPlayerTime( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "playerTime" ) ))
        self()->mPlayerTime = v;
    }

    /**
      Get time limit for the local player
    */
    static
    QDateTime playerTime()
    {
      return self()->mPlayerTime;
    }

    /**
      Set time increment per move for the local player
    */
    static
    void setPlayerTimeIncrement( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "playerTimeIncrement" ) ))
        self()->mPlayerTimeIncrement = v;
    }

    /**
      Get time increment per move for the local player
    */
    static
    QDateTime playerTimeIncrement()
    {
      return self()->mPlayerTimeIncrement;
    }

    /**
      Set time limit for the computer or remote player
    */
    static
    void setOpponentTime( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "opponentTime" ) ))
        self()->mOpponentTime = v;
    }

    /**
      Get time limit for the computer or remote player
    */
    static
    QDateTime opponentTime()
    {
      return self()->mOpponentTime;
    }

    /**
      Set time increment per move for the computer or remote player
    */
    static
    void setOpponentTimeIncrement( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "opponentTimeIncrement" ) ))
        self()->mOpponentTimeIncrement = v;
    }

    /**
      Get time increment per move for the computer or remote player
    */
    static
    QDateTime opponentTimeIncrement()
    {
      return self()->mOpponentTimeIncrement;
    }

    /**
      Set whether both players have the same time limit
    */
    static
    void setSameTime( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "sameTime" ) ))
        self()->mSameTime = v;
    }

    /**
      Get whether both players have the same time limit
    */
    static
    bool sameTime()
    {
      return self()->mSameTime;
    }

    /**
      Set whether time limits are enabled and displayed
    */
    static
    void setTimeEnabled( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "timeEnabled" ) ))
        self()->mTimeEnabled = v;
    }

    /**
      Get whether time limits are enabled and displayed
    */
    static
    bool timeEnabled()
    {
      return self()->mTimeEnabled;
    }

    /**
      Set protocol to be used for communication to opponent
    */
    static
    void setProtocol( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "protocol" ) ))
        self()->mProtocol = v;
    }

    /**
      Get protocol to be used for communication to opponent
    */
    static
    int protocol()
    {
      return self()->mProtocol;
    }

    /**
      Set the local human player's color in a game against a computer or over the Internet.
    */
    static
    void setColor( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "color" ) ))
        self()->mColor = v;
    }

    /**
      Get the local human player's color in a game against a computer or over the Internet.
    */
    static
    int color()
    {
      return self()->mColor;
    }

    /**
      Set program to run
    */
    static
    void setProgram( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "program" ) ))
        self()->mProgram = v;
    }

    /**
      Get program to run
    */
    static
    QString program()
    {
      return self()->mProgram;
    }

    /**
      Set username for the Free Internet Chess Server
    */
    static
    void setFicsUsername( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ficsUsername" ) ))
        self()->mFicsUsername = v;
    }

    /**
      Get username for the Free Internet Chess Server
    */
    static
    QString ficsUsername()
    {
      return self()->mFicsUsername;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // KGameTheme
    QString mTheme;

    // Preferences
    int mAnimationSpeed;
    bool mAnimateBoard;
    int mBorderDisplayType;
    bool mShowDanger;
    bool mShowMarker;
    bool mShowMotion;
    QDateTime mPlayerTime;
    QDateTime mPlayerTimeIncrement;
    QDateTime mOpponentTime;
    QDateTime mOpponentTimeIncrement;
    bool mSameTime;
    bool mTimeEnabled;

    // Protocols
    int mProtocol;
    int mColor;
    QString mProgram;
    QString mFicsUsername;

  private:
};

#endif

